// {{{RME classifier 'Logical View::CContextAddin'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "CContextAddin.h"
#endif

#include <RTSystem/contextAddin.h>
#include <CContextAddin.h>
#include <AddInCollection.h>
#include <AddInManager.h>
#include <Capsule.h>
#include <Class.h>
#include <Classifier.h>
#include <ClassifierCollection.h>
#include <ControllableElement.h>
#include <LogicalPackage.h>
#include <Model.h>
#include <RichType.h>
#include <_Application.h>
#include <_ControllableElementCollection.h>
#include <frmSelection.h>

// {{{RME classifier 'Logical View::CContextAddin' tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR tool 'OT::Cpp' property 'ImplementationPreface'
IMPLEMENT_DYNCREATE(CContextAddin, CCmdTarget)
BEGIN_MESSAGE_MAP(CContextAddin, CCmdTarget)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CContextAddin, CCmdTarget)
	DISP_FUNCTION(CContextAddin, "RunTest", RunTest, VT_EMPTY, VTS_DISPATCH)
	DISP_FUNCTION(CContextAddin, "OnActivate", OnActivate, VT_EMPTY, VTS_DISPATCH)
	DISP_FUNCTION(CContextAddin, "OnEnableContextMenuItemsForObjects", OnEnableContextMenuItemsForObjects, VT_BOOL, VTS_DISPATCH VTS_DISPATCH)
	DISP_FUNCTION(CContextAddin, "OnSelectedContextMenuItemForObjects", OnSelectedContextMenuItemForObjects, VT_BOOL, VTS_DISPATCH VTS_BSTR VTS_DISPATCH)
END_DISPATCH_MAP()

BEGIN_INTERFACE_MAP(CContextAddin, CCmdTarget)
	INTERFACE_PART(CContextAddin, interfaceID, Dispatch)
END_INTERFACE_MAP()

IMPLEMENT_OLECREATE(CContextAddin, addinName, 
0x9a6dcf2c, 0xc8db, 0x48f5, 0x9f, 0xfe, 0xb7, 0x9f, 0x49, 0xa7, 0x7c, 0x63);

// }}}USR
// }}}RME

// {{{RME classifier 'Logical View::CContextAddin' operation 'OnFinalRelease()'
void CContextAddin::OnFinalRelease( void )
{
	// {{{USR operation 'OnFinalRelease()'
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::CContextAddin' operation '~CContextAddin()'
CContextAddin::~CContextAddin( void )
{
	// {{{USR operation '~CContextAddin()'
	// To terminate the application when all objects created with
	// 	with OLE automation, the destructor calls AfxOleUnlockApp.
		
	AfxOleUnlockApp();
	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::CContextAddin' operation 'CContextAddin()'
CContextAddin::CContextAddin( void )
	// {{{USR tool 'OT::Cpp' property 'ConstructorInitializer'
	// }}}USR
{
	// {{{USR operation 'CContextAddin()'
	EnableAutomation();
		
	// To keep the application running as long as an OLE automation 
	//	object is active, the constructor calls AfxOleLockApp.
		
	AfxOleLockApp();
	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::CContextAddin' operation 'RunTest(LPDISPATCH)'
void CContextAddin::RunTest( LPDISPATCH theApp )
{
	// {{{USR operation 'RunTest(LPDISPATCH)'
	/***************************************************************/
	// This is the actual code called by the Tools Menu/Run Context Addin...
	// The code is an adaptation of the Visual Basic code given in the
	//  first tutorial of RRTEI.
	/***************************************************************/

	theApp->AddRef();
	_Application theRTApp(theApp);

	Model theModel;
	ClassifierCollection SelectedClasses;
	ClassifierCollection SelectedCapsules;
	Class aClass;
	Capsule aCapsule;

	theModel=theRTApp.GetCurrentModel();
	SelectedClasses=theModel.GetSelectedClasses();
	SelectedCapsules=theModel.GetSelectedCapsules();

	// The following stores the capsules and classes' names
	//  in data structures in the frmSelection object so that
	//  the information can later be placed in the list boxes
	//  when the dialog get initialised.
	frmSelection theDialog=new frmSelection();
	for (int i=0 ; i<(SelectedCapsules.GetCount()) ; i++)
	{
		theDialog.numCapsules++;
		aCapsule=Capsule(SelectedCapsules.GetAt(i+1));
		theDialog.capsules[i]=aCapsule.GetName();;
	}
	for (i=0; i<(SelectedClasses.GetCount()); i++)
	{
		theDialog.numClasses++;
		aClass=Class(SelectedClasses.GetAt(i+1));
		theDialog.classes[i]=aClass.GetName();
	}

	// Display the dialog.
	theDialog.DoModal();
	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::CContextAddin' operation 'OnActivate(LPDISPATCH)'
void CContextAddin::OnActivate( LPDISPATCH theApp )
{
	// {{{USR operation 'OnActivate(LPDISPATCH)'
	// Do the following as soon as the AddIn is loaded.

	theApp->AddRef();

	_Application pRoseApp(theApp);
	AddInManager aManager;

	ContextMenuItem aContextMenu;
	AddInCollection AddIns;
	aManager=AddInManager(pRoseApp.GetAddInManager());
	AddIns=AddInCollection(aManager.GetAddIns());

	if (AddIns.FindFirst("contextAddin")<=0)
	{
		AfxMessageBox("I'm sorry. I could not find my addin. Shuting Down...");
		return;
	}

	MyAddin_ = AddIn(AddIns.GetFirst("contextAddin"));

	// Add items to the Context Menu of Capsules.
	ContextMenuItem sub1(MyAddin_.AddContextMenuItemForClass("Capsule","Submenu Context Addin",""));
	MyMenuItems_[0]=ContextMenuItem(MyAddin_.AddContextMenuItemForClass("Capsule","Run Command 1","command1"));
	MyMenuItems_[1]=ContextMenuItem(MyAddin_.AddContextMenuItemForClass("Capsule","Run Command 2","command2"));
	ContextMenuItem sub2(MyAddin_.AddContextMenuItemForClass("Capsule","EndSubmenu",""));
	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::CContextAddin' operation 'OnEnableContextMenuItemsForObjects(LPDISPATCH,LPDISPATCH)'
BOOL CContextAddin::OnEnableContextMenuItemsForObjects( LPDISPATCH theApp, LPDISPATCH theCollection )
{
	// {{{USR operation 'OnEnableContextMenuItemsForObjects(LPDISPATCH,LPDISPATCH)'
	// The following is executed once the user decides to
	//  invoke a context menu.
	theApp->AddRef();
	theCollection->AddRef();

	_Application pRoseApp(theApp);
	_ControllableElementCollection items(theCollection);

	// If the number of selected capsules is less than or
	//  equal to 1 disable the first command otherwise,
	//  allow both commands to be executed.
	if (items.GetCount() > 1)
	{
		RichType rsEnabled(MyMenuItems_[0].GetMenuState());
		rsEnabled.SetValue(1);
		return FALSE;
	}
	else
	{
		RichType rsDisabled(MyMenuItems_[0].GetMenuState());
		rsDisabled.SetValue(0);
		return TRUE;
	}

	return TRUE;
	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::CContextAddin' operation 'OnSelectedContextMenuItemForObjects(LPDISPATCH,LPCTSTR,LPDISPATCH)'
BOOL CContextAddin::OnSelectedContextMenuItemForObjects( LPDISPATCH theApp, LPCTSTR theName, LPDISPATCH theCollection )
{
	// {{{USR operation 'OnSelectedContextMenuItemForObjects(LPDISPATCH,LPCTSTR,LPDISPATCH)'
	// The following is executed once the user clicks on 
	//  one of our context menu items.
	theCollection->AddRef();
	_ControllableElementCollection items(theCollection);

	CString msg(theName);
	msg = msg + ": ";
	ControllableElement myElement;

	for (int i=1; i<=items.GetCount(); i++)
	{
			myElement=ControllableElement(items.GetAt(i));
			msg=msg+myElement.GetName()+" ";
	}

	AfxMessageBox(msg);

	return TRUE;
	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::CContextAddin' classAttribute 'interfaceID'
IID interfaceID = { 0xd2aab448, 0xafda, 0x4bab, { 0xa0, 0x10, 0x1a, 0xf0, 0xc5, 0x63, 0x52, 0x3a } };;
// }}}RME

// {{{RME classifier 'Logical View::CContextAddin' classAttribute 'addinName'
char * addinName = _T("contextAddin.contextAddin")
;
// }}}RME

// {{{RME classifier 'Logical View::CContextAddin' tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR tool 'OT::Cpp' property 'ImplementationEnding'
// }}}USR
// }}}RME

// }}}RME
