// {{{RME classifier 'Logical View::RRTEI::Component'

#ifndef Component_H
#define Component_H

#ifdef PRAGMA
#pragma interface "Component.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::Component' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class Component : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::Component' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::Component' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::Component' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::Component' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~Component( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	Component & operator=( const Component & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'Component()'
	Component( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'Component(LPDISPATCH)'
	Component( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'Component(const Component&)'
	Component( const Component & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetVersion()'
	CString GetVersion( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'Save()'
	BOOL Save( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'IsClass(LPCTSTR)'
	BOOL IsClass( LPCTSTR theClassName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'IdentifyClass()'
	CString IdentifyClass( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'IsSameInstance(LPDISPATCH)'
	BOOL IsSameInstance( LPDISPATCH Other );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetName()'
	CString GetName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetToolNames()'
	LPDISPATCH GetToolNames( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'SetName(LPCTSTR)'
	void SetName( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetApplication()'
	LPDISPATCH GetApplication( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetModel()'
	LPDISPATCH GetModel( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetDocumentation()'
	CString GetDocumentation( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'SetDocumentation(LPCTSTR)'
	void SetDocumentation( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetStereotype()'
	CString GetStereotype( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'SetStereotype(LPCTSTR)'
	void SetStereotype( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetLocalizedStereotype()'
	CString GetLocalizedStereotype( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'SetLocalizedStereotype(LPCTSTR)'
	void SetLocalizedStereotype( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetExternalDocuments()'
	LPDISPATCH GetExternalDocuments( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetControlNewUnits()'
	BOOL GetControlNewUnits( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'SetControlNewUnits(BOOL)'
	void SetControlNewUnits( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetUniqueID()'
	CString GetUniqueID( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetQualifiedName()'
	CString GetQualifiedName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetCurrentPropertySetName(LPCTSTR)'
	CString GetCurrentPropertySetName( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'OverrideProperty(LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL OverrideProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'InheritProperty(LPCTSTR,LPCTSTR)'
	BOOL InheritProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'CreateProperty(LPCTSTR,LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL CreateProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetDefaultPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetDefaultPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'FindProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetAllProperties()'
	LPDISPATCH GetAllProperties( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetToolProperties(LPCTSTR)'
	LPDISPATCH GetToolProperties( LPCTSTR theToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'IsOverriddenProperty(LPCTSTR,LPCTSTR)'
	BOOL IsOverriddenProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'IsDefaultProperty(LPCTSTR,LPCTSTR)'
	BOOL IsDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'FindDefaultProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetPropertyClassName()'
	CString GetPropertyClassName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetDefaultSetNames(LPCTSTR)'
	LPDISPATCH GetDefaultSetNames( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'SetCurrentPropertySetName(LPCTSTR,LPCTSTR)'
	BOOL SetCurrentPropertySetName( LPCTSTR ToolName, LPCTSTR SetName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'IsControlled()'
	BOOL IsControlled( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'IsModified()'
	BOOL IsModified( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'IsModifiable()'
	BOOL IsModifiable( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetFileName()'
	CString GetFileName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetContainingControlledElement()'
	LPDISPATCH GetContainingControlledElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetControlledChildElements(BOOL)'
	LPDISPATCH GetControlledChildElements( BOOL bRecursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'IsOwned()'
	BOOL IsOwned( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'IsUnderSourceControl()'
	BOOL IsUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'IsCheckedOut()'
	BOOL IsCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'IsLoaded()'
	BOOL IsLoaded( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'Uncontrol()'
	BOOL Uncontrol( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'ControlChildElements(BOOL)'
	BOOL ControlChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'UncontrolChildElements(BOOL)'
	BOOL UncontrolChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'ControlTo(LPCTSTR)'
	BOOL ControlTo( LPCTSTR Path );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'Control()'
	BOOL Control( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'IsChildDirUnderSourceControl()'
	BOOL IsChildDirUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'IsControllableElementContainer()'
	BOOL IsControllableElementContainer( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'IsChildDirCheckedOut()'
	BOOL IsChildDirCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetChildDirName()'
	CString GetChildDirName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'IsScratchPad()'
	BOOL IsScratchPad( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetModelElement()'
	LPDISPATCH GetModelElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'DeleteExternalDocument(LPDISPATCH)'
	BOOL DeleteExternalDocument( LPDISPATCH pIDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'AddExternalDocument(LPCTSTR,long)'
	LPDISPATCH AddExternalDocument( LPCTSTR szName, long iType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'OpenSpecification()'
	BOOL OpenSpecification( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetRealizeRelations()'
	LPDISPATCH GetRealizeRelations( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetAllClasses()'
	LPDISPATCH GetAllClasses( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetType()'
	CString GetType( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'SetType(LPCTSTR)'
	void SetType( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetParentComponentPackage()'
	LPDISPATCH GetParentComponentPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetAssignedClasses()'
	LPDISPATCH GetAssignedClasses( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetAssignedLogicalPackages()'
	LPDISPATCH GetAssignedLogicalPackages( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetEnvironment()'
	CString GetEnvironment( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'SetEnvironment(LPCTSTR)'
	void SetEnvironment( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'AssignClass(LPDISPATCH)'
	BOOL AssignClass( LPDISPATCH theClass );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'UnassignClass(LPDISPATCH)'
	BOOL UnassignClass( LPDISPATCH theClass );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'AssignPackage(LPDISPATCH)'
	BOOL AssignPackage( LPDISPATCH thePackage );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'UnassignPackage(LPDISPATCH)'
	BOOL UnassignPackage( LPDISPATCH thePackage );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'GetComponentDependencies()'
	LPDISPATCH GetComponentDependencies( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'AddComponentDependency(LPDISPATCH)'
	LPDISPATCH AddComponentDependency( LPDISPATCH theDep );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'DeleteComponentDependency(LPDISPATCH)'
	BOOL DeleteComponentDependency( LPDISPATCH theDep );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'AddRealizeRelation(LPCTSTR,LPCTSTR)'
	LPDISPATCH AddRealizeRelation( LPCTSTR theRelName, LPCTSTR theInterfaceName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'DeleteRealizeRelation(LPDISPATCH)'
	BOOL DeleteRealizeRelation( LPDISPATCH theRel );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'Verify(BOOL)'
	BOOL Verify( BOOL bUpdateAssignedClassList );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'Generate(BOOL)'
	BOOL Generate( BOOL bUpdateAssignedClassList );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'Build(BOOL)'
	BOOL Build( BOOL bUpdateAssignedClassList );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'RebuildAll(BOOL)'
	BOOL RebuildAll( BOOL bUpdateAssignedClassList );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'UpdateAssignedClassList()'
	BOOL UpdateAssignedClassList( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'ReverifyAll(BOOL)'
	BOOL ReverifyAll( BOOL bUpdateAssignedClassList );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Component' operation 'RegenerateAll(BOOL)'
	BOOL RegenerateAll( BOOL bUpdateAssignedClassList );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::Component' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* Component_H */

// }}}RME
