// {{{RME classifier 'Logical View::RRTEI::ComponentPackage'

#ifndef ComponentPackage_H
#define ComponentPackage_H

#ifdef PRAGMA
#pragma interface "ComponentPackage.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class ComponentPackage : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~ComponentPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	ComponentPackage & operator=( const ComponentPackage & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'ComponentPackage()'
	ComponentPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'ComponentPackage(LPDISPATCH)'
	ComponentPackage( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'ComponentPackage(const ComponentPackage&)'
	ComponentPackage( const ComponentPackage & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetVersion()'
	CString GetVersion( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'Save()'
	BOOL Save( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'IsClass(LPCTSTR)'
	BOOL IsClass( LPCTSTR theClassName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'IdentifyClass()'
	CString IdentifyClass( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'IsSameInstance(LPDISPATCH)'
	BOOL IsSameInstance( LPDISPATCH Other );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetName()'
	CString GetName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetToolNames()'
	LPDISPATCH GetToolNames( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'SetName(LPCTSTR)'
	void SetName( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetApplication()'
	LPDISPATCH GetApplication( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetModel()'
	LPDISPATCH GetModel( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetDocumentation()'
	CString GetDocumentation( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'SetDocumentation(LPCTSTR)'
	void SetDocumentation( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetStereotype()'
	CString GetStereotype( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'SetStereotype(LPCTSTR)'
	void SetStereotype( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetLocalizedStereotype()'
	CString GetLocalizedStereotype( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'SetLocalizedStereotype(LPCTSTR)'
	void SetLocalizedStereotype( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetExternalDocuments()'
	LPDISPATCH GetExternalDocuments( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetControlNewUnits()'
	BOOL GetControlNewUnits( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'SetControlNewUnits(BOOL)'
	void SetControlNewUnits( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetUniqueID()'
	CString GetUniqueID( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetQualifiedName()'
	CString GetQualifiedName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetCurrentPropertySetName(LPCTSTR)'
	CString GetCurrentPropertySetName( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'OverrideProperty(LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL OverrideProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'InheritProperty(LPCTSTR,LPCTSTR)'
	BOOL InheritProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'CreateProperty(LPCTSTR,LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL CreateProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetDefaultPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetDefaultPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'FindProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetAllProperties()'
	LPDISPATCH GetAllProperties( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetToolProperties(LPCTSTR)'
	LPDISPATCH GetToolProperties( LPCTSTR theToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'IsOverriddenProperty(LPCTSTR,LPCTSTR)'
	BOOL IsOverriddenProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'IsDefaultProperty(LPCTSTR,LPCTSTR)'
	BOOL IsDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'FindDefaultProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetPropertyClassName()'
	CString GetPropertyClassName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetDefaultSetNames(LPCTSTR)'
	LPDISPATCH GetDefaultSetNames( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'SetCurrentPropertySetName(LPCTSTR,LPCTSTR)'
	BOOL SetCurrentPropertySetName( LPCTSTR ToolName, LPCTSTR SetName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'IsControlled()'
	BOOL IsControlled( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'IsModified()'
	BOOL IsModified( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'IsModifiable()'
	BOOL IsModifiable( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetFileName()'
	CString GetFileName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetContainingControlledElement()'
	LPDISPATCH GetContainingControlledElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetControlledChildElements(BOOL)'
	LPDISPATCH GetControlledChildElements( BOOL bRecursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'IsOwned()'
	BOOL IsOwned( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'IsUnderSourceControl()'
	BOOL IsUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'IsCheckedOut()'
	BOOL IsCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'IsLoaded()'
	BOOL IsLoaded( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'Uncontrol()'
	BOOL Uncontrol( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'ControlChildElements(BOOL)'
	BOOL ControlChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'UncontrolChildElements(BOOL)'
	BOOL UncontrolChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'ControlTo(LPCTSTR)'
	BOOL ControlTo( LPCTSTR Path );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'Control()'
	BOOL Control( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'IsChildDirUnderSourceControl()'
	BOOL IsChildDirUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'IsControllableElementContainer()'
	BOOL IsControllableElementContainer( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'IsChildDirCheckedOut()'
	BOOL IsChildDirCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetChildDirName()'
	CString GetChildDirName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'IsScratchPad()'
	BOOL IsScratchPad( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetModelElement()'
	LPDISPATCH GetModelElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'DeleteExternalDocument(LPDISPATCH)'
	BOOL DeleteExternalDocument( LPDISPATCH pIDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'AddExternalDocument(LPCTSTR,long)'
	LPDISPATCH AddExternalDocument( LPCTSTR szName, long iType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'OpenSpecification()'
	BOOL OpenSpecification( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'IsRootPackage()'
	BOOL IsRootPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'ImportFile(LPCTSTR)'
	BOOL ImportFile( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'AddUnit(LPCTSTR)'
	BOOL AddUnit( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'AddSharedUnit(LPCTSTR)'
	BOOL AddSharedUnit( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'ImportFileEx(LPCTSTR)'
	LPDISPATCH ImportFileEx( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'TopLevel()'
	BOOL TopLevel( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetAllComponents()'
	LPDISPATCH GetAllComponents( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetAllComponentPackages()'
	LPDISPATCH GetAllComponentPackages( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetParentComponentPackage()'
	LPDISPATCH GetParentComponentPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetComponentDependencies()'
	LPDISPATCH GetComponentDependencies( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetComponentPackages()'
	LPDISPATCH GetComponentPackages( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetComponents()'
	LPDISPATCH GetComponents( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetComponentDiagrams()'
	LPDISPATCH GetComponentDiagrams( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'AddComponent(LPCTSTR)'
	LPDISPATCH AddComponent( LPCTSTR theName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'AddComponentDiagram(LPCTSTR)'
	LPDISPATCH AddComponentDiagram( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'AddComponentPackage(LPCTSTR)'
	LPDISPATCH AddComponentPackage( LPCTSTR theName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'RelocateComponent(LPDISPATCH)'
	void RelocateComponent( LPDISPATCH theComponent );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'RelocateComponentPackage(LPDISPATCH)'
	void RelocateComponentPackage( LPDISPATCH theComponentPackage );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'RelocateComponentDiagram(LPDISPATCH)'
	void RelocateComponentDiagram( LPDISPATCH theModDiagram );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetVisibleComponentPackages()'
	LPDISPATCH GetVisibleComponentPackages( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'GetComponentPackageDependencies(LPDISPATCH)'
	LPDISPATCH GetComponentPackageDependencies( LPDISPATCH theComponentPackage );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'DeleteComponent(LPDISPATCH)'
	BOOL DeleteComponent( LPDISPATCH pIDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' operation 'DeleteComponentPackage(LPDISPATCH)'
	BOOL DeleteComponentPackage( LPDISPATCH pIDispatch );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::ComponentPackage' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* ComponentPackage_H */

// }}}RME
