// {{{RME classifier 'Logical View::RRTEI::ModelElement'

#ifndef ModelElement_H
#define ModelElement_H

#ifdef PRAGMA
#pragma interface "ModelElement.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::ModelElement' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class ModelElement : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~ModelElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	ModelElement & operator=( const ModelElement & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'ModelElement()'
	ModelElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'ModelElement(LPDISPATCH)'
	ModelElement( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'ModelElement(const ModelElement&)'
	ModelElement( const ModelElement & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetVersion()'
	CString GetVersion( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'Save()'
	BOOL Save( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'IsClass(LPCTSTR)'
	BOOL IsClass( LPCTSTR theClassName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'IdentifyClass()'
	CString IdentifyClass( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'IsSameInstance(LPDISPATCH)'
	BOOL IsSameInstance( LPDISPATCH Other );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetName()'
	CString GetName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetToolNames()'
	LPDISPATCH GetToolNames( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'SetName(LPCTSTR)'
	void SetName( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetApplication()'
	LPDISPATCH GetApplication( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetModel()'
	LPDISPATCH GetModel( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetDocumentation()'
	CString GetDocumentation( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'SetDocumentation(LPCTSTR)'
	void SetDocumentation( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetStereotype()'
	CString GetStereotype( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'SetStereotype(LPCTSTR)'
	void SetStereotype( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetLocalizedStereotype()'
	CString GetLocalizedStereotype( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'SetLocalizedStereotype(LPCTSTR)'
	void SetLocalizedStereotype( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetExternalDocuments()'
	LPDISPATCH GetExternalDocuments( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetControlNewUnits()'
	BOOL GetControlNewUnits( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'SetControlNewUnits(BOOL)'
	void SetControlNewUnits( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetUniqueID()'
	CString GetUniqueID( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetQualifiedName()'
	CString GetQualifiedName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetCurrentPropertySetName(LPCTSTR)'
	CString GetCurrentPropertySetName( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'OverrideProperty(LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL OverrideProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'InheritProperty(LPCTSTR,LPCTSTR)'
	BOOL InheritProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'CreateProperty(LPCTSTR,LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL CreateProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetDefaultPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetDefaultPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'FindProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetAllProperties()'
	LPDISPATCH GetAllProperties( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetToolProperties(LPCTSTR)'
	LPDISPATCH GetToolProperties( LPCTSTR theToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'IsOverriddenProperty(LPCTSTR,LPCTSTR)'
	BOOL IsOverriddenProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'IsDefaultProperty(LPCTSTR,LPCTSTR)'
	BOOL IsDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'FindDefaultProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetPropertyClassName()'
	CString GetPropertyClassName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetDefaultSetNames(LPCTSTR)'
	LPDISPATCH GetDefaultSetNames( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'SetCurrentPropertySetName(LPCTSTR,LPCTSTR)'
	BOOL SetCurrentPropertySetName( LPCTSTR ToolName, LPCTSTR SetName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'IsControlled()'
	BOOL IsControlled( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'IsModified()'
	BOOL IsModified( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'IsModifiable()'
	BOOL IsModifiable( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetFileName()'
	CString GetFileName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetContainingControlledElement()'
	LPDISPATCH GetContainingControlledElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetControlledChildElements(BOOL)'
	LPDISPATCH GetControlledChildElements( BOOL bRecursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'IsOwned()'
	BOOL IsOwned( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'IsUnderSourceControl()'
	BOOL IsUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'IsCheckedOut()'
	BOOL IsCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'IsLoaded()'
	BOOL IsLoaded( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'Uncontrol()'
	BOOL Uncontrol( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'ControlChildElements(BOOL)'
	BOOL ControlChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'UncontrolChildElements(BOOL)'
	BOOL UncontrolChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'ControlTo(LPCTSTR)'
	BOOL ControlTo( LPCTSTR Path );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'Control()'
	BOOL Control( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'IsChildDirUnderSourceControl()'
	BOOL IsChildDirUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'IsControllableElementContainer()'
	BOOL IsControllableElementContainer( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'IsChildDirCheckedOut()'
	BOOL IsChildDirCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetChildDirName()'
	CString GetChildDirName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'IsScratchPad()'
	BOOL IsScratchPad( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'GetModelElement()'
	LPDISPATCH GetModelElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'DeleteExternalDocument(LPDISPATCH)'
	BOOL DeleteExternalDocument( LPDISPATCH pIDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'AddExternalDocument(LPCTSTR,long)'
	LPDISPATCH AddExternalDocument( LPCTSTR szName, long iType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ModelElement' operation 'OpenSpecification()'
	BOOL OpenSpecification( void );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::ModelElement' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* ModelElement_H */

// }}}RME
