// {{{RME classifier 'Logical View::RRTEI::PathMap'

#ifndef PathMap_H
#define PathMap_H

#ifdef PRAGMA
#pragma interface "PathMap.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::PathMap' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class PathMap : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::PathMap' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::PathMap' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::PathMap' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::PathMap' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~PathMap( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::PathMap' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	PathMap & operator=( const PathMap & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::PathMap' operation 'PathMap()'
	PathMap( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::PathMap' operation 'PathMap(LPDISPATCH)'
	PathMap( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::PathMap' operation 'PathMap(const PathMap&)'
	PathMap( const PathMap & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::PathMap' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::PathMap' operation 'AddEntry(LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL AddEntry( LPCTSTR Symbol, LPCTSTR Path, LPCTSTR Comment );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::PathMap' operation 'DeleteEntry(LPCTSTR)'
	BOOL DeleteEntry( LPCTSTR Symbol );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::PathMap' operation 'GetActualPath(LPCTSTR)'
	CString GetActualPath( LPCTSTR VirtualPath );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::PathMap' operation 'GetVirtualPath(LPCTSTR)'
	CString GetVirtualPath( LPCTSTR ActualPath );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::PathMap' operation 'HasEntry(LPCTSTR)'
	BOOL HasEntry( LPCTSTR Symbol );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::PathMap' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* PathMap_H */

// }}}RME
